/*
* Brian R Taylor
* brian.taylor@bolderflight.com
* 
* Copyright (c) 2021 Bolder Flight Systems Inc
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the “Software”), to
* deal in the Software without restriction, including without limitation the
* rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
* sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
* IN THE SOFTWARE.
*/

#include "statistics.h"

void setup() {
  Serial.begin(115200);
  while (!Serial) {}

  bfs::RunningStats<float> w;
  for (unsigned int i = 0; i < 10; i++) {
    w.Update((float) i);
  }
  Serial.print("Mean: ");
  Serial.println(w.mean()); // 4.5
  Serial.print("Variance: ");
  Serial.println(w.var()); // 9.1667
  Serial.print("Standard Deviation: ");
  Serial.println(w.std()); // 3.0277

  bfs::MovingWindowStats<float, 3> m;
  for (unsigned int i = 0; i < 10; i++) {
    m.Update((float) i);
    Serial.print(m.mean());
    Serial.print("\t");
    Serial.print(m.var());
    Serial.print("\t");
    Serial.println(m.std());
  }
}

void loop() {}
